library(haven)
library(reshape2)
#UCLA data (one index)
wide_scores <- read.csv('https://stats.idre.ucla.edu/stat/r/faq/hsb2.csv')

long_scores <- melt(wide_scores, id.vars=c("id", "female", "race", "ses", "schtyp", "prog"), variable.name = "subj", value.name = "score")

back_to_wide_scores <- dcast(long_scores, id+female+race+ses+schtyp+prog~subj, value.var = "score")


#STATA data (two indexes)
wide_stata <- read_dta("VARSTOCASES.dta")

long_stata <- melt(wide_stata, id.vars = c("ID"), variable.name = "index", value.name = "outcome")
long_stata <- data.frame(ID = long_stata$ID, gender = substr(long_stata$index, 2, 2), time = substr(long_stata$index, 3, 3), outcome = long_stata$outcome)

combined_indexes <- data.frame(ID = long_stata$ID, index = paste(long_stata$gender, long_stata$time), outcome = long_stata$outcome)
back_to_wide_stata <- dcast(combined_indexes, ID~index, value.var="outcome")





